#include <iostream>
#include <vector>
#include "histogram.h"
#include "histogram_internal.h"
using namespace std;

bool find_minmax(const vector<double>& numbers, double& min, double& max) {
    if(numbers.empty()){
        return false;
    }
    else{
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        if (x > max) {
            max = x;
        }
    }
    return true;
    }
}

// 
vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count) {
    double min, max;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count, 0);

    for (double number : numbers) {
        size_t bin_index = static_cast<size_t>((number - min) / bin_size);
        if (bin_index >= bin_count) {
            bin_index = bin_count - 1;
        }
        bins[bin_index]++;
    }

    return bins;
}
